unit hiMultiBlockFind;

interface

uses Windows, Kol, Share, Debug;

const
  _NEXT     = #1;
  _EXCLUDE  = #2;
  _INCLUDE  = #3;
  
  _COMMENTS = #1;
  _COMMENTE = #2;
  
  _ENTER    = #13#10; 

type
 THiMultiBlockFind = class(TDebug)
  private
    FListTag: PStrList;
    FCount: integer;    
    procedure SetTagList(Value: string);
    procedure SetCount(Value: integer);    
  public
    _data_Text,
    _event_onEnd: THI_Event;

    onResult: array of THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doMultiBlockFind(var _Data:TData; index:word);
    procedure _work_doTagList(var _Data:TData; index:word);    

    property _prop_TagList: string write SetTagList; 
    property _prop_Count: integer write SetCount; 
 end;

implementation

uses hiStr_Enum;

function Trim(const Str : string): string;
var
  L: integer;
begin
  Result := Str;
  L := Length(Result);
  while (L > 0) and (Result[L] <= ' ') do Dec(L);
  SetLength(Result, L);
  L := 1;
  while (L <= Length(Result)) and (Result[L] <= ' ') do Inc(L);
  Result := string(PChar(integer(@Result[1]) + L - 1)); 
end;

procedure Replace(var str: string; const substr, dest: string);
var
  p, r: integer;
  sb: string;
begin
  p := PosEx(substr, str);
  r := length(substr);
  while p > 0 do
  begin
    sb := CopyEnd(str, p + r);  
    SetLength(str, p - 1);
    str := str + dest + sb;
    p := p + Length(dest);
    p := PosEx(substr, str, p);
  end;
end;

procedure THiMultiBlockFind.SetCount;
begin
  SetLength(onResult, Value);
  FCount := Value;
end;

procedure THiMultiBlockFind.SetTagList;
var
  s, st: string;
begin
  st := Trim(Value);
  s := '';

  Replace(st, '{**c', _COMMENTS);
  Replace(st, 'c**}', _COMMENTE);

  repeat
    s := s + fparse(st, _COMMENTS);
    if  st <> '' then
      fparse(st, _COMMENTE);  
  until st = '';  

  Replace(s, '{**s}', '');
  Replace(s, '{**n}', _NEXT);
  Replace(s, '{**x}', _EXCLUDE);
  Replace(s, '{**i}', _INCLUDE);
  Replace(s, _ENTER, '');
  Replace(s, '{**e}', _ENTER);

  FListTag.Text := s;
end;

constructor THiMultiBlockFind.Create;
begin
  inherited;
  FListTag := NewStrList;
end;

destructor THiMultiBlockFind.Destroy;
begin
  FListTag.free;
  inherited;
end;  

procedure THiMultiBlockFind._work_doMultiBlockFind;
var
  i: integer;

  Text: string;
  dt: TData;
  mt: PMT;
  initmt: boolean;  
  
  function findblock(text, tgch: string): boolean;
  var
    i, j: integer;
    res, startbl, endbl: string;
    include: boolean;
  begin
      endbl := trim(fparse(tgch, _NEXT));
      startbl := trim(fparse(endbl, _EXCLUDE));

      if endbl = '' then
      begin
        endbl := startbl;
        startbl := fparse(endbl, _INCLUDE);
        include := true;        
      end
      else
        include := false;        
      endbl := trim(endbl);

      i := pos(startbl, Text);
      j := 0;

      while i > 0 do
      begin
        j := PosEx(endbl, Text, i + Length(startbl));
        if j = 0 then break;
        
        res := Copy(Text, i + Length(startbl), j - i - Length(startbl));
        if include then
          res := startbl + res + endbl;

        tgch := trim(tgch);   
        if (tgch = '') and initmt then
        begin
          dtString(dt, res);
          mt := mt_make(dt);
          initmt := false;
        end
        else if (tgch = '') and not initmt then  
          mt_string(mt, res)
        else
          findblock(res, tgch);

        inc(j, Length(endbl));
        i := PosEx(startbl, Text, j);
      end;

      if j = 0 then
        Result := false
      else
        Result := true;        
  end;
  
begin
  text := ReadString(_Data, _data_Text);
  dtNull(dt);
  if (FListTag.Count = 0) or (text = '') then exit; 

  for i := 0 to FListTag.Count - 1 do
  begin
    mt := nil;
    initmt := true;
    findblock(text, FListTag.Items[i]);
    if(i >= 0) and (i < FCount) then
      _hi_onEvent(onResult[i], dt);
    if Assigned(mt) then mt_free(mt);      
  end  
end;

procedure THiMultiBlockFind._work_doTagList;
begin
  _prop_TagList := ToString(_Data);
end;

end.